plugins/shop/routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register admin routes for your plugin. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" and "admin" middleware groups. Now create a great admin panel !
|
*/
Route::middleware('can:shop.admin')->group(function () {
    Route::get('/settings', 'SettingController@show')->name('settings');
    Route::post('/settings', 'SettingController@save')->name('settings.save');

    Route::resource('categories', 'CategoryController')->except(['index', 'show']);
    Route::resource('packages', 'PackageController')->except('show');
    Route::resource('payments', 'PaymentController')->only('index');
    Route::resource('purchases', 'PurchaseController')->only('index');
    Route::resource('offers', 'OfferController')->except('show');
    Route::resource('coupons', 'CouponController')->except('show');
    Route::resource('discounts', 'DiscountController')->except('show');
    Route::resource('gateways', 'GatewayController')->except(['show', 'create']);

    Route::post('/packages/update-order', 'PackageController@updateOrder')->name('packages.update-order');
    Route::post('/packages/{package}/clone', 'PackageController@clone')->name('packages.clone');
    Route::get('/gateways/create/{type}', 'GatewayController@create')->name('gateways.create');
});

plugins/shop/routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your plugin. These
| routes are loaded by the RouteServiceProvider of your plugin within
| a group which contains the "web" middleware group and your plugin name
| as prefix. Now create something great!
|
*/

Route::get('/', 'CategoryController@index')->name('home');
Route::resource('categories', 'CategoryController')->only('show');

Route::resource('packages', 'PackageController')->only('show');
Route::post('/packages/{package}/buy', 'PackageController@buy')->name('packages.buy')->middleware('auth');

Route::prefix('offers')->name('offers.')->middleware('auth')->group(function () {
    Route::get('/', 'OfferController@selectPayment')->name('select');
    Route::get('/{gateway:type}', 'OfferController@buy')->name('buy');
    Route::post('/{offer:id}/{gateway:type}', 'OfferController@pay')->name('pay');
});

Route::prefix('cart')->name('cart.')->middleware('auth')->group(function () {
    Route::get('/', 'CartController@index')->name('index');
    Route::post('/', 'CartController@update')->name('update');
    // TODO Match multiple methods is not really good here...
    Route::match(['GET', 'POST'], '/remove/{package}', 'CartController@remove')->name('remove');
    Route::post('/clear', 'CartController@clear')->name('clear');
    Route::post('/payment', 'CartController@payment')->name('payment')->middleware('auth');

    Route::prefix('coupons')->name('coupons.')->group(function () {
        Route::post('/add', 'CouponController@add')->name('add');
        Route::post('/remove/{coupon}', 'CouponController@remove')->name('remove');
        Route::post('/clear', 'CouponController@clear')->name('clear');
    });
});

Route::prefix('payments')->name('payments.')->group(function () {
    Route::middleware('auth')->group(function () {
        Route::get('/payment', 'PaymentController@payment')->name('payment');
        Route::post('/{gateway:type}/pay', 'PaymentController@pay')->name('pay');
    });

    Route::get('/{gateway:type}/success', 'PaymentController@success')->name('success');
    Route::get('/{gateway:type}/failure', 'PaymentController@failure')->name('failure');
});

plugins/shop/resources/views/admin/elements/select.blade.php
@push('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">
    <style>
        .bootstrap-select {
            width: 100%!important;
            display: block!important;
        }
    </style>
@endpush

@push('scripts')
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/js/bootstrap-select.min.js" defer></script>
@endpush

@push('footer-scripts')
    <script>
        document.querySelectorAll('select[multiple]').forEach(function (el) {
            el.classList.remove('custom-select', 'form-control');
            el.classList.add('selectpicker');
        });
    </script>
@endpush

plugins/shop/resources/views/admin/settings.blade.php
@extends('admin.layouts.admin')

@section('title', trans('shop::admin.settings.title'))

@section('content')
    <div class="card shadow mb-4">
        <div class="card-body">

            <form action="{{ route('shop.admin.settings') }}" method="POST">
                @csrf

                <div class="form-group">
                    <label for="currencySelect">{{ trans('shop::messages.fields.currency') }}</label>

                    <select class="custom-select @error('currency') is-invalid @enderror" id="currencySelect" name="currency">
                        @foreach($currencies as $code => $name)
                            <option value="{{ $code }}" @if($currentCurrency === $code) selected @endif>{{ $name }}</option>
                        @endforeach
                    </select>
                </div>

                <div class="form-group">
                    <div class="custom-control custom-switch">
                        <input type="checkbox" class="custom-control-input" id="useSiteMoneyCheckbox" name="use-site-money" @if(use_site_money()) checked @endif>
                        <label class="custom-control-label" for="useSiteMoneyCheckbox">{{ trans('shop::admin.settings.use-site-money') }}</label>
                    </div>
                </div>

                <div class="form-group">
                    <label for="goalInput">{{ trans('shop::messages.month-goal') }}</label>

                    <div class="input-group">
                        <input type="number" min="0" class="form-control @error('goal') is-invalid @enderror" id="goalInput" name="goal" value="{{ old('goal', $goal ?? '') }}">
                        <div class="input-group-append">
                            <span class="input-group-text">{{ currency_display() }}</span>
                        </div>

                        @error('goal')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>
                </div>

                <button type="submit" class="btn btn-primary">
                    <i class="fas fa-save"></i> {{ trans('messages.actions.save') }}
                </button>
            </form>

        </div>
    </div>
@endsection

plugins/shop/resources/views/categories/index.blade.php
@extends('layouts.app')

@section('title', trans('shop::messages.title'))

@section('content')
    <div class="container content">
        <div class="alert alert-warning" role="alert">
            {{ trans('shop::messages.categories.empty') }}
        </div>
    </div>
@endsection

plugins/shop/resources/views/categories/show.blade.php
@extends('layouts.app')

@section('title', $category->name)

@push('footer-scripts')
    <script>
        document.querySelectorAll('[data-package-url]').forEach(function (el) {
            el.addEventListener('click', function (ev) {
                ev.preventDefault();

                axios.get(el.dataset['packageUrl'], {
                    headers: {
                        'X-PJAX': 'true'
                    }
                }).then(function (response) {
                    $('#itemModal').html(response.data).modal('show');
                }).catch(function (error) {
                    createAlert('danger', error, true);
                });
            });
        });
    </script>
@endpush

@section('content')
    <div class="container content">
        <div class="row">
            <div class="col-lg-3">
                @include('shop::categories.sidebar')
            </div>

            <div class="col-lg-9">
                <div class="row">
                    @forelse($category->packages as $package)
                        <div class="col-md-4 mb-4">
                            <div class="card h-100">
                                @if($package->image !== null)
                                    <a href="#" data-package-url="{{ route('shop.packages.show', $package) }}">
                                        <img class="card-img-top" src="{{ $package->imageUrl() }}" alt="{{ $package->name }}">
                                    </a>
                                @endif

                                <div class="card-body">
                                    <h4 class="card-title">{{ $package->name }}</h4>
                                    <h5>
                                        @if($package->isDiscounted())
                                            <del class="small">{{ $package->getOriginalPrice() }}</del>
                                        @endif
                                        {{ shop_format_amount($package->getPrice()) }}
                                    </h5>

                                    <a href="#" class="btn btn-primary btn-block" data-package-url="{{ route('shop.packages.show', $package) }}">
                                        {{ trans('shop::messages.buy') }}
                                    </a>
                                </div>
                            </div>
                        </div>
                    @empty
                        <div class="col">
                            <div class="alert alert-warning" role="alert">
                                {{ trans('shop::messages.categories.empty') }}
                            </div>
                        </div>
                    @endforelse
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="itemModal" tabindex="-1" role="dialog" aria-labelledby="itemModalLabel" aria-hidden="true"></div>
@endsection

plugins/shop/resources/views/categories/sidebar.blade.php
<div class="list-group mb-3">
    @foreach($categories as $subCategory)
        <a href="{{ route('shop.categories.show', $subCategory) }}" class="list-group-item @if($category->is($subCategory)) active @endif">{{ $subCategory->name }}</a>
    @endforeach
</div>

@auth
    <div class="mb-4">
        @if(use_site_money())
            <p class="text-center">{{ trans('messages.fields.money') }}: {{ format_money(auth()->user()->money) }}</p>

            <a href="{{ route('shop.offers.select') }}" class="btn btn-primary btn-block">{{ trans('shop::messages.cart.credit') }}</a>
        @endif

        <a href="{{ route('shop.cart.index') }}" class="btn btn-primary btn-block">{{ trans('shop::messages.cart.title') }}</a>
    </div>
@endauth

@if($goal)
    <div class="mb-4">
        <h4>{{ trans('shop::messages.month-goal') }}</h4>

        <div class="progress mb-1">
            <div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" aria-valuenow="{{ $goal }}" aria-valuemin="0" aria-valuemax="100" style="width: {{ $goal }}%"></div>
        </div>

        <p class="text-center">{{ trans_choice('shop::messages.month-goal-current', $goal) }}</p>
    </div>
@endif

plugins/shop/resources/views/offers/payment.blade.php
@extends('layouts.app')

@section('title', trans('shop::messages.offers.title-payment'))

@section('content')
    <div class="container content">
        <h1>{{ trans('shop::messages.offers.title-payment') }}</h1>

        <div class="row">
            @forelse($gateways as $gateway)
                <div class="col-md-3">
                    <div class="card shadow-sm mb-3">
                        <a href="{{ route('shop.offers.buy', $gateway) }}" class="payment-method">
                            <div class="card-body text-center">
                                <img src="{{ $gateway->paymentMethod()->image() }}" style="max-height: 45px" class="img-fluid" alt="{{ $gateway->name }}">
                            </div>
                        </a>
                    </div>
                </div>
            @empty
                <div class="col">
                    <div class="alert alert-warning" role="alert">
                        {{ trans('shop::messages.payment.empty') }}
                    </div>
                </div>
            @endforelse
        </div>
    </div>
@endsection

plugins/shop/resources/views/offers/select.blade.php
@extends('layouts.app')

@section('title', trans('shop::messages.offers.title-select'))

@push('footer-scripts')
    <script>
        document.querySelectorAll('.payment-method').forEach(function (el) {
            el.addEventListener('click', function (ev) {
                ev.preventDefault();

                const form = document.getElementById('submitForm');
                form.action = el.href;
                form.submit();
            });
        });
    </script>
@endpush

@section('content')
    <div class="container content">
        <h1>{{ trans('shop::messages.offers.title-select') }}</h1>

        <div class="row">
            @forelse($offers as $offer)
                <div class="col-md-3">
                    <div class="card shadow-sm mb-3">
                        <a href="{{ route('shop.offers.pay', [$offer->id, $gateway->type]) }}" class="payment-method">
                            <div class="card-body text-center">
                                <h3>{{ $offer->name }}</h3>
                                <h4>{{ $offer->price }} {{ currency_display() }}</h4>
                            </div>
                        </a>
                    </div>
                </div>
            @empty
                <div class="col">
                    <div class="alert alert-warning" role="alert">
                        {{ trans('shop::messages.offers.empty') }}
                    </div>
                </div>
            @endforelse
        </div>
    </div>

    <form method="POST" id="submitForm">
        @csrf
    </form>
@endsection